{$I tttvers.pas}
(*  Ohne Primzahlen
   Funktionen, auf die Jaochim Mohr in seinen Programmen
   nicht mehr verzichten mchte.
   (c) Joachim Mohr, Rottenburg am Neckar

   Die Unit darf frei in nichtkommerziellen Programmen verwendet
   werden, wenn der CopyRight-Vermerk nicht entfernt wird.
   Kritik, Anregungen, Verbesserungsvorschlge bitte an

   Joachim_Mohr@t-online.de
*)

unit jmMath;

interface

FUNCTION TermToReal(s: string;x:extended): extended; overload;
Function TermToReal(s: string)       : extended; overload;
function TermToRealTolerant(const s:string):extended;
function ErmittleBruch(const q:extended;var a,b:extended; eps_Genauigkeit:Extended):boolean;
FUNCTION ReellZuBruch(const q:extended):string;
FUNCTION ReellZuGemZahl(const q:extended):string;
function loeseLGS2(a1,b1,c1,a2,b2,c2:extended;
            var x1,x2:extended):boolean; //=true bei eindeutiger Lsung
function loeseLGS3(a1,b1,c1,d1,a2,b2,c2,d2,a3,b3,c3,d3:extended;
            var x1,x2,x3:extended;var mathError:string):boolean; //=true bei Erfolg
//------- Hifsfunktionen -------------
function gaussKl(x:extended):extended; //=Gaus'sche Klammerfunktion
function log10tol(z:extended):extended; //Toleranter 10-er Logarithmus
function min(a,b:Extended):Extended; overload;
function max(a,b:Extended):Extended; overload;
function min(a,b:Integer):Integer; overload;
function max(a,b:Integer):Integer; overload;
function ArcTan2(Y, X: Extended): Extended;
function ArcCos(X: Extended): Extended;
function ArcSin(X: Extended): Extended;
function IstInteger(const x:extended; eps_Genauigkeit:extended):boolean;
  //z.B. x=2,000..0001 x=1,999..9
function HochReal(x,y:Extended):Extended;
function bruch_(r:extended;MaxNennerStellen,stellen:integer;
                           LeerWennKeinBruch,
                           AuchUnecht:boolean):string;

implementation

uses jmhilf,controls,dialogs,sysutils;

const g_eps=1E-15;

//Allgemeine Funktionen
procedure raiseEMathErrorcreate(s:string);
begin
 raise EMathError.create('Fehler:'+s);
end;

function ohneLeerzeichenf(const s:string):string;
   var n:integer;
 begin
   result:=s;
   repeat
     n:=pos(' ',result);
     if n>0 then result:=copy(result,1,n-1)+copyab(result,n+1)
   until n=0;
 end;

//----------- im Parser vorkommende Funktionen -----------------

function hoch(const x:extended; n:integer):extended; //x^n  n El Z
  begin
    if n<0 then result:=1/hoch(x,-n) else //x^n=1/x^(-n) fr n<0
      if n=0 then  result:=1 else
        result:=x*hoch(x,n-1)//rekursiv
  end;


function ArcTan2(Y, X: Extended): Extended;
asm
        FLD     Y
        FLD     X
        FPATAN
        FWAIT
end;

function ArcCos(X: Extended): Extended;
begin
  Result := ArcTan2(Sqrt(1 - X*X), X);
end;

function ArcSin(X: Extended): Extended;
begin
  Result := ArcTan2(X, Sqrt(1 - X*X))
end;


function asn(x:extended):extended; //arcsin
begin
  result:=0;
  if abs(x-1)<1E-15 then result:=pi/2 else     //asn(1)=Pi/2
    if abs(x+1)<1E-15 then result:=-Pi/2 else  //asn(-1)=-Pi/2
    if x*x<1 then result:=arcsin(x) //siehe unit tttmath
     else raiseEMathErrorcreate('asn'+FloatToStr(x))
end;

function acs(x:extended):extended;   //Arccos
begin
 result:=0;
 if abs(x-1)<1E-15 then result:=0 else
   if abs(x+1)<1E-15 then result:=Pi else
     if x*x<1 then result:=arcCos(x) //siehe unit tttmath
     else raiseEMathErrorcreate('asn'+floatToStr(x))
end;

function tan(x:extended):extended;
begin
 result:=0;
 if cos(x)<>0 then tan:=sin(x)/cos(x)
    else raiseEMathErrorcreate('tan'+FloatToStr(x))
end;

function wurzel(x:extended):extended;
begin
  result:=0;
  if x>=-1E-15 //nicht negativ bis auf Rundungsfehler
    then wurzel:=sqrt(x)
      else raiseEMathErrorcreate('sqr'+floatToStr(x))
end;



//----------------- Es folgt ein Parser ---------------------

FUNCTION TermToReal(s: string;x:extended): extended; overload;//rekursiv!
                                  // s beliebiger Term ohne wissensch Not
                                  // d.h. 1E-17 nicht erlaubt
    var u,v,p,q: string;
    function e(c:char): boolean; //falls mglich wird s zerlegt in s=u+c+v
            //z.B. s=(5+4)*(3+2) Bei c='+' wird u=(5+4) und v=(3+2). Dann e=true
            //    Bei c='*' wird wegen der Klammern e=false
          var i,k:integer;
      begin k:=0; // k zhlt die Klammern
            i:=length(s)+1;
            repeat  dec(i);
              if s[i]=')' then inc(k);
              if s[i]='(' then k:=pred(k)
            until (i=1) or ((k=0) and (s[i]=c));
            if i=1 then Begin
              if k<>0 then
                raiseEMathErrorcreate(s+'|'+floatToStr(k)+' Klammern zu viel!');
              result:=false
            End else Begin
              result:=true;
              u:=copy(s,1,i-1);
              v:=copyab(s,i+1)
            End
      end;
 begin
   result:=0;
   s:=OhneLeerzeichenf(s);
   u:=copy(s,1,3);
   v:=copyab(s,4);
   p:=copy(s,1,2);
   q:=copyab(s,3);
   if s='' then Begin result:=0; exit End;
   if s[1]='-' then s:='0'+s; //zB. s='-7/3x+14' -> s='0-7/3x+14'
 try {*****}
 {Punkt- vor Strichrechnung und vor Potenzen}
 if e('+') then result:=TermToReal(u,x)+TermToReal(v,x)        else
 if e('-') then result:=TermToReal(u,x)-TermToReal(v,x)        else
 if e('*') then result:=TermToReal(u,x)*TermToReal(v,x)        else
 if e('') then result:=TermToReal(u,x)*TermToReal(v,x)        else //''=#183
 if e('/') or e(':') then Begin
   try result:=TermToReal(u,x)/TermToReal(v,x);
   except raiseEMathErrorcreate(u+'/'+v) end
 End else
  if e('^') then result:=hoch(TermToReal(u,x),round(TermToReal(v,x)))  else
  if p='lg' then Begin
    try result:=ln(TermToReal(q,x))/ln(10)
    Except raiseEMathErrorcreate('Lg'+q) End;
  End else
  if p='ln' then Begin
    try result:=ln(TermToReal(q,x))
    except raiseEMathErrorcreate('ln'+q) End
  End else
  if p='lb' then Begin
    try result:=ln(TermToReal(q,x))/ln(2);
    except raiseEMathErrorcreate('lb'+q) End
  End else
  if u='sin' then result:=sin(TermToReal(v,x))             else //sin im Bogenma
  if u='cos' then result:=cos(TermToReal(v,x))             else
  if u='si_' then result:=sin(Pi/180*TermToReal(v,x))      else //sin im Gradma
  if u='atn' then Begin
    try result:=arctan(TermToReal(v,x));
    except raiseEMathErrorcreate('atn'+v) End
  End else
  if u='asn' then result:=asn(TermToReal(v,x)) {Fehler s.o.} else
  if u='acs' then result:=acs(TermToReal(v,x)) {Fehler bei asn} else
  if u='at_' then Begin  //arTan im Gradma
    try result:=arctan(TermToReal(v,x))*180/Pi;
    except raiseEMathErrorcreate('at_'+v) End
  End else
  if u='as_' then Begin //arcsin im Gradma
    try result:=asn(TermToReal(v,x))*180/Pi;
    except raiseEMathErrorcreate('as_'+v) End
  End else
  if u='ac_' then Begin //arccos im Gradma
    try result:=acs(TermToReal(v,x))*180/Pi;
    except raiseEMathErrorcreate('ac_'+v) End
  End      else
  if u='co_' then Begin  //arccos im Gradma
    try result:=cos(Pi/180*TermToReal(v,x));
    except raiseEMathErrorcreate('co_'+v) End
  End      else
  if u='tan' then Begin
    try result:=tan(TermToReal(v,x));
    except raiseEMathErrorcreate('tan'+v) End
  End             else
  if u='ta_' then Begin
    try result:=tan(Pi/180*TermToReal(v,x));
    except raiseEMathErrorcreate('ta_'+v) End
  End else
  if u='abs' then result:=abs(TermToReal(v,x))             else
  if u='exp' then result:=exp(TermToReal(v,x))             else
  if u='wur' then result:=wurzel(TermToReal(v,x))          else //Dort Fehler
  if u='int' then result:=int(TermToReal(v,x))             else
  if u='rou' then result:=int(TermToReal(v,x)+0.5)         else
  if s[1]='(' then Begin
     while (length(s)>1) and (s[length(s)]<>')') do s:=copy(s,1,length(s)-1);
    //z.B. 12*(250+50) DM
    s:=copy(s,2,length(s)-2);
    result:=TermToReal(s,x)
  End else if s='Pi' then result:=Pi else
    if s='x' then result:=x else //Variable x
    BEgin
      try result:=strToFloat(s); except raiseEMathErrorcreate('Syntaxf. in '+s); result:=0; exit end;
    ENd
  except {******} raiseEMathErrorcreate('Fehler in '+s) end;
 end;

Function TermToReal(s: string): extended; overload;
  const dummy=0;
begin
  result:=termToReal(s,dummy);
end;

//------------------------------ Es folgt Bruc darstellung  ------------------------
function char_(const s:string; const k:integer):char; //falls k zu gross ' '
begin if (k<=0) or (k>length(s)) then result:=' ' else result:=s[k] end;

function char_last(const s:string):char;
begin result:=char_(s,length(s)) end;

FUNCTION ggtInt(a,b:longint):longint;
  begin if b=0 then result:=a
        else result:=ggtInt(b,a mod b); //...ist gttlich
  end;

FUNCTION ggtReal(a,b:Extended):Extended;
  begin if (a<maxlongint) and (b<maxlongint) then
           result:=ggTInt(round(a),round(b))
        else Begin
          if abs(b)<0.5 then result:=a
          else result:=ggtReal(b,a-b*int(a/b));
        end;
end;

PROCEDURE kuerzeReal(var a,b:Extended);
    var t:Extended;
  begin t:=ggtReal(a,b);
        a:=a/t;
        b:=b/t
  end;

function ErmittleBruch(const q:extended;var a,b:extended; eps_Genauigkeit:Extended):boolean;
       //=true, falls erfolgreich
    const MaxIteration=50;
    var q0,Qabs,GanzZahligerAnteilVonQ,NachkommaVonQ,am,amm,bmm,bm:extended;
       {am=a index -1 amm index -2}
        zaehl:integer;
begin //Methode: Kettenbruchentwicklung
  result:=true;
  qabs:=abs(q); //Es wird mit positiven Werten gerechnet
  q0:=qabs;
  a:=1;
  b:=0;
  am:=0; //altes a
  bm:=1; //altes b
  zaehl:=0;
  try //damit nach exit Finally ausgefhrt wird
    repeat
      inc(zaehl);
      if zaehl>MaxIteration then exit; //falls eps_Genauigkeit zu knapp
      GanzZahligerAnteilVonQ:=int(q0+eps_Genauigkeit); //wg. Rundungsfeler muss z.B.  4.99.. zu 5.00.. werden
      NachkommaVonQ:=q0-GanzZahligerAnteilVonQ;        //=fraq(qabs)
      amm:=am; //uraltes a
      bmm:=bm; //uraltes b
      am:=a;   //altes   a
      bm:=b;   //altes   a
      try // mglich overflow (kommt nur vor, falls eps_Gen. zu klein)
        a:=GanzZahligerAnteilVonQ*am+amm; //Anfang: ak=GanzZahligerAnteilVonQ
        b:=GanzZahligerAnteilVonQ*bm+bmm; //        bk=1
        kuerzeReal(a,b);
      Except exit End;
      if NachkommaVonq<eps_Genauigkeit then exit;//endlicher Kettenbruch
      q0:=1/NachkommaVonq; //Jetzt ja NachkommaVonq>=Genauigkeit
    until abs(qabs-a/b)<eps_Genauigkeit;
  Finally
    if abs(qabs-a/b)>=eps_Genauigkeit then result:=false;
    if q<0 then a:=-a;
  End;
end;

function TermToRealTolerant(const s:string):extended;
begin
  try result:=TermToReal(s);
  except result:=0; {Keine Fehlermeldung} End;
end;

function ReellZuBruch_(const q:extended;const alsGemZahl:boolean):string;
  const Hochkomma=#39;
  var a,b,g,r:extended;
      Erf:boolean;
  function ohneE(const s:string):string; //z.b. 1,4379...E18
      var p,n:integer;
          a:string;
    begin
       p:=pos('E',s);
       a:=copy(s,1,p-1);
       n:=StrToInt(copyab(s,p+1));
       result:=char_(a,1)+copyab(a,3);
       while length(result)<n do result:=result+'0';
    end;
begin
  erf:=ErmittleBruch(q,a,b,g_eps);  //1/2+1/7 wird mit Fehler<g_eps berechnet
  //Teste auch 9,999 999 999  und Pi/4
  if not erf or (abs(a)*abs(b)>1E14) then  Begin
    result:=trim(FloatToStrF(q,ffFixed,18,10));
    if pos('E',result)>0 then result:=OhneE(result) else
      while (pos(Decimalseparator,result)>0) and (char_last(result)='0')
        and (pos(Decimalseparator,result)<length(result)-1) do kup(result);
  End else if b=1 then result:=FloatToStr(a) else Begin
    if alsGemZahl and (abs(q)>1) then BEgin
      g:=int(abs(q));     //g ganzzahliger Teil von q
      r:=abs(a)-g*b;     //da a=g*b+r  q=a/b=g+r/b
      result:=FloatToStr(g)+Hochkomma+FloatToStr(r)+'/'+FloatToStr(b);
      if q<0 then result:='-'+result;
    ENd else result:=FloatToStr(a)+'/'+FloatToStr(b);
  End;
end;

function ReellZuBruch(const q:extended):string;
begin result:=ReellZuBruch_(q,false) end;

function ReellZuGemZahl(const q:extended):string;
begin result:=ReellZuBruch_(q,true) end;

function bruch_(r:extended;MaxNennerStellen,stellen:integer;
                           LeerWennKeinBruch,
                           AuchUnecht:boolean):string;
   var  AnzahlDerStellenDesNenners:integer;
        z,n: extended;
        vz,vzAmAnfang,bruch,gemZahl:string;
  begin
        if isTInteger(r,g_eps) then Begin
          if LeerWennKeinBruch then result:='' else
          result:=floatToStr(r);
          exit
        End;
        if r<0 then Begin
          vzAmAnfang:='-';
          vz:='-';
        End else Begin
          vzAmAnfang:='';
          vz:='+'
        End;
        r:=abs(r);
        if ErmittleBruch(abs(r),z,n,g_eps) then
          AnzahlDerStellenDesNenners:=round(log10tol(z)) else
            AnzahlDerStellenDesNenners:=0;
        if (AnzahlDerStellenDesNenners>0)
          and (AnzahlDerStellenDesNenners<=MaxNennerStellen) then Begin
            bruch:=vzAmAnfang+floatToStr(z)+'/'+FloatToStr(n);
            if r>1 then BEgin //gemischte Zahl
                gemZahl:=VzAmAnfang+floatToStr(gaussKl(r))+vz+floatToStr(z-gaussKl(r)*n)+'/'+floatToStr(n);
            ENd else gemZahl:=bruch;
            if (r>1) and AuchUnecht then result:=bruch+'='+gemzahl
            else result:=bruch;//gemZahl;
            exit;
        End;
   if LeerWennKeinBruch then result:='' else
     if stellen=0 then result:=VzAmAnfang+FloatToStr(r) else
       result:=VzAmAnfang+FloatToStr(round(hochReal(10,Stellen)*r)/hochReal(10,Stellen));
  end;

function RealIsIntegerToStr(x:extended):string;
begin
  result:=trim(floatToStrf(x,ffGeneral,4,18));
end;

function VielfachesVonPi(x:extended):string;
   var z,n:extended;
begin
  result:=''; //Misserfolg
  if ErmittleBruch(x/Pi,z,n,1E-15) then Begin
     if abs(n)<1000000 then BEgin
       if n=1 then result:=RealIsIntegerToStr(z)+'*Pi' else
         result:=RealIsIntegerToStr(z)+'/'+RealIsIntegerToStr(n)+'*Pi'
     ENd;
  End;
end;

function FrageAbbruch:boolean; //=true, wenn Abgebrochen werden soll
begin
  if MessageDlg('Suche nach Wurzelausdruck kann lange dauern. Suche jetzt abbrechen?',
                 mtConfirmation, [mbYes, mbNo], 0) = mrYes then
                   result:=true else result:=false;
end;

function IsInteger(const x:extended;eps_Genauigkeit:extended):boolean;
   //eps_Genauigkeit>=1E-19
   var x0:Extended;
begin
  x0:=abs(x);
  while x0>1 do Begin
    x0:=x0/2;
    eps_Genauigkeit:=eps_Genauigkeit*2;
  End; // 1000000,001 oder 1,000000001 werden gleich behandelt
  result:=frac(abs(x)+eps_Genauigkeit)<eps_Genauigkeit*2;
end;

function loeseLGS2(a1,b1,c1,a2,b2,c2:extended;
                    var x1,x2:extended):boolean; //=true bei eindeutiger Lsung
          //a1x1+b1x2=c1
          //a2x1+b2x2=c2
  var Diskriminante:extended;
begin
try
  Diskriminante:=a1*b2-a2*b1;
  if Diskriminante=0 then Begin
      result:=false;
      x1:=0;
      x2:=0;
      exit;
  End else Begin
    result:=true;
    x2:=(a1*c2-a2*c1)/Diskriminante; //Die Determinantenregel
    if a1=0 then x1:=c2/a2-b2/a2*x2 else x1:=c1/a1-b1/a1*x2; //nicht a1=0 und a2=0
  End;
except result:=false {theoretisch nicht mglich} End;
end;

function loeseLGS3(a1,b1,c1,d1,a2,b2,c2,d2,a3,b3,c3,d3:extended;
                     var x1,x2,x3:extended;var mathError:string):boolean;
          //a1x1+b1x2+c1x3=d1
          //a2x1+b2x2+c2x3=d2
          //a3x1+b3x2+c3x3=d3
          //Matherror muss am Anfang='' gesetzt werden
          //Um Stackberlauf zu verhindern, gibt es eine Bremse.
begin
  {pr(ss(a1)+'#'+ss(b1)+'#'+ss(c1)+'#'+ss(d1)+#13+
      ss(a2)+'#'+ss(b2)+'#'+ss(c2)+'#'+ss(d2)+#13+
      ss(a3)+'#'+ss(b3)+'#'+ss(c3)+'#'+ss(d3));}
  result:=false;
  if a1=0 then Begin if a2<>0 then //Vertausche die Zeilen
    result:=loeseLGS3(
              a2,b2,c2,d2,a1,b1,c1,d1,a3,b3,c3,d3,x1,x2,x3,mathError) else if a3<>0 then
    result:=loeseLGS3(
              a3,b3,c3,d3,a2,b2,c2,d2,a1,b1,c1,d1,x1,x2,x3,matherror) else
      exit; //sollte nicht vorkommen
  End else Begin
    //Jetzt a1<>0 Mache zwei Gleichungen mit 2 Unbekannten
    //                   x1+       b1/a1x2+      c1/a1x3=       d1/a1  (1')
    //(2)-a2(1')  (a2-a2)x1+(b2-a2b1/a1)x2+(c2-a2c1/a1)x3=(d2-a2d1/a1)
    //(3)-a1(1')  (a3-a3)x1+(b3-a3b1/a1)x2+(c3-a3c1/a1)x3=(d3-a3d1/a1)
    if loeseLGS2(a1*b2-a2*b1,a1*c2-a2*c1,a1*d2-a2*d1,
                 a1*b3-a3*b1,a1*c3-a3*c1,a1*d3-a3*d1,x2,x3) then BEgin
      //gelungen!!
      result:=true;
      x1:=d1/a1-b1/a1*x2-c1/a1*x3;
    ENd else BEgin
      //Vertausche: Spalte1->Spalte2->spalte3->Spalte1
      Matherror:=Matherror+'*'; //'**' heit: bisher zwei mal vertauscht
                                //3. Vertauschung=erster Versuch
      if length(Matherror)>=3 then exit; //verhindern nicht terminierte Rekursion
      result:=loeseLGS3(b1,c1,a1,d1,b2,c2,a2,d2,b3,c3,a3,d3,x2,x3,x1,matherror);
    ENd;
   End;
end;


function GaussKl(x:extended):extended;
begin
  result:=int(x); //z.B. int(-2.4)=-2 statt -3
  if x<result then result:=result-1
end;


function log10tol(z:extended):extended; //Toleranter 10-er Logarithmus
begin if z<=0 then result:=-maxint else result:=ln(z)/ln(10) end;

function min(a,b:Extended):Extended; overload;
  begin if a<b then result:=a else result:=b end;
function max(a,b:Extended):Extended; overload;
  begin if a<b then result:=b else result:=a end;
function min(a,b:Integer):Integer; overload;
  begin if a<b then result:=a else result:=b end;
function max(a,b:Integer):Integer; overload;
  begin if a<b then result:=b else result:=a end;


function IstInteger(const x:extended;eps_Genauigkeit:extended):boolean;
begin
  {while x0>1 do Begin
    x0:=x0/2;
    eps_Genauigkeit:=eps_Genauigkeit*2;
  End; // 1000000,001 oder 1,000000001 werden gleich behandelt}
  result:=frac(abs(x)+eps_Genauigkeit)<eps_Genauigkeit*2;
end;

function HochInt(X:Extended; n:Integer):Extended;
begin
  if n<0 then result:=1.0/HochInt(x,-n) else Begin //Iterativ
    Result:=1.0;
    while n>0 do BEgin
      while not Odd(n) do
      BEGin
        n:=n shr 1;
        X:=X*X
      END;
      Dec(n);
      Result:=Result*X
    ENd;
  End;
end;

function HochReal(x,y: Extended): Extended;
begin
  try
  if y=0.0 then Result:=1.0  {x^0=1 0^x=0}
    else if (x=0.0) and (y>0) then Result:=0.0
      else if IsInteger(y,1E-18) and (Abs(y)<=MaxInt) then
       Result:=HochInt(x,Integer(Round(y)))
         else Result:=Exp(y*Ln(x))
  except raise EMathError.Create('Potenzieren') end;
end;







end.
