{$I tttvers.pas}
unit tttwave;
{Ausgerichtete Recordfelder aus!!!}
{$A-}
interface

uses Classes, mmsystem, WinProcs;
const samplingrate = 441; //fr eine 1/100-Sekunde
  Anzahl_stereokanaele = 4;
type
  TRiffHeader = record
    riff: Array[0..3] OF Char;
    filesize: LongInt;
    typeStr: Array[0..3] OF Char;
  end;
  TChunkRec = record
    id: Array[0..3] OF Char;
    size: LongInt;
  end;
  TWaveFormatRec = record
    tag: Word;
    channels: Word;
    samplesPerSec: LongInt;
    bytesPerSec: LongInt;
    blockAlign: Word;
  end;

  TPCMWaveFormatRec = record
    wf: TWaveFormatRec;
    bitsPerSample: Word;
  end;
  TWAVHeader = record { WAV Format }
    riffHdr: TRiffHeader;
    fmtChunk: TChunkRec;
    fmt: TPCMWaveFormatRec;
    dataChunk: TChunkRec;
    { data follows here }
  end;
function GetWaveVolume: DWord;
procedure SetWaveVolume(const AVolume: DWord);
procedure LautstaerkeMittel;

procedure spiele(fr1, fr2, fr3, fr4, fr5, fr6, fr7, fr8: single; cs: Cardinal;
  dauernd: boolean; art: char; mitSpeichern: string); //cs=CentiSekuns
procedure dreiklang;
procedure EinzelnerTon;
implementation


procedure HeadInit(var Header: TWAVHeader);
begin
  with Header do
  begin
    with riffHdr do
    begin
        //Schreibe 'RIFF' in die ersten 4 bytes
      riff[0] := char($52); riff[1] := char($49); riff[2] := char($46); riff[3] := char($46);
        // wird spaeter gesetzt;
      filesize := 0;
        //Schreibe 'WAVE' in die naechsten 4 bytes
      typeStr[0] := char($57); typeStr[1] := char($41); typeStr[2] := char($56); typeStr[3] := char($45);
    end;
    with fmtChunk do
    begin
        //Schreibe 'fmt' + char($20) in die naechsten 4 bytes
      id[0] := char($66); id[1] := char($6D); id[2] := char($74); id[3] := char($20);
      size := $10;
    end;
    with fmt.wf do
    begin
        //its 16 bit, 44kHz Stereo
      tag := 1; channels := 2;
      samplesPerSec := $AC44;
      bytesPerSec := MakeLong($B110, $2);
      blockAlign := 4;
      fmt.bitsPerSample := $10;
    end;
    with dataChunk do
    begin
        //Schreibe 'data' in die naechsten 4 bytes
      id[0] := char($64); id[1] := char($61); id[2] := char($74); id[3] := char($61);
      size := 0;
    end;
  end;
end;

function f0(const k: Longword; art: char): SmallInt; //k=i*Frequ i:=0 to ...
begin
  if art = 's' then Begin //Sinus
    result := Round(sin((k * Pi) / 22050) * 32000) div Anzahl_stereokanaele;
    exit;
  end;
  if art = 'o' then Begin //Orgel
    result := Round(sin((k * Pi) / 22050) * 32000) div (2 * Anzahl_stereokanaele) +
      Round(sin((2 * k * Pi) / 22050) * 32000) div (4 * Anzahl_stereokanaele) + //1.Oberton
      Round(sin((3 * k * Pi) / 22050) * 32000) div (6 * Anzahl_stereokanaele); //2.Oberton}
    exit;
  end;
    //Rechtecksfunktion
  if odd(round(k / (50 * samplingrate))) then result := 4000 else result := -4000;
    //50 = 100 (CentiSekunden)/2
end;


function Abtastwert(const k1, k2, k3, k4: Longword; art: char): SmallInt;
var r1, r2, r3, r4: SmallInt;
begin //z.B. k=i*frw1 (fr i=441*500(5Sek) frw1=100)=max=220500000
                                           //Longword=0..4294967295
  r1 := f0(k1, art);
  if (k2 > 0) and (k2 <> k1) then r2 := f0(k2, art) else r2 := r1;
  if (k3 > 0) and (k3 <> k1) then r3 := f0(k3, art) else r3 := r1;
  if (k4 > 0) and (k4 <> k1) then r4 := f0(k4, art) else r4 := r1;
  result := r1 + r2 + r3 + r4;
end;


procedure spiele(fr1, fr2, fr3, fr4, fr5, fr6, fr7, fr8: single; cs: Cardinal;
  dauernd: boolean; art: char; mitSpeichern: string); //cs=CentiSekuns
const Ausgabekanal_wird_bereits_verwendet = 'Ausgabekanal wird bereits verwendet!';
var ms: TMemoryStream;
  Header: TWavHeader;
  i: integer; //z.B. i=0 to 441*500=441500 (5 Sekunden)
  s: SmallInt;
  frw1, frw2, frw3, frw4, frw5, frw6, frw7, frw8: word;
  schongeladen: boolean;
begin
  frw1 := round(fr1);
  frw2 := round(fr2);
  frw3 := round(fr3);
  frw4 := round(fr4);
  frw5 := round(fr5);
  frw6 := round(fr6);
  frw7 := round(fr7);
  frw8 := round(fr8);
  HeadInit(Header);
  Header.Datachunk.size := samplingrate * cs * 2 * 2; //441*cs Samples pro sekunde,
                                                //2 Channels, 2Bytes (16bit)
  //FileSize = DataSize + HeaderSize
  Header.riffHdr.FileSize := Header.Datachunk.size + 24;
  ms := TMemoryStream.Create;
  schongeladen := true;
  if mitSpeichern > '' then Begin
    try ms.LoadFromFile(TTWpfad + MitSpeichern + '.wav');
    except schongeladen := false; ENd
  End Else schongeladen := false;
  try
    if not schongeladen then Begin
      ms.Seek(0, 0);
      //Write Header to Stream
      ms.Write(Header, sizeof(header));
      //form here: just data chunks. in this case (16bit stereo):
      // 16bit LeftValue, 16bit Right Value, 16bit LeftValue, 16bit Right Value ...
      // in the range of a SmallInt
      if cs <= 0 then exit; //kein Ton. Sollte nicht vorkommen
      for i := 0 to samplingrate * cs - 2 do BEgin
        //Writing left channel
        s := Abtastwert(i * frw1, i * frw2, i * frw3, i * frw4, art); //i*frw1=max=441*500*1000Hz
        ms.Write(s, 2);
        //Writing to right channel
        if (fr5 <> 0) or (fr6 <> 0) or (fr7 <> 0) or (fr8 <> 0) then
          if (fr5 <> fr1) or (fr6 <> fr2) or (fr7 <> fr3) or (fr8 <> fr4)
            then s := Abtastwert(i * frw5, i * frw6, i * frw7, i * frw8, art);
        ms.Write(s, 2);
      ENd;
      if mitSpeichern > '' then ms.SaveToFile(TTWpfad + MitSpeichern + '.wav');
    End;
  Finally
    if dauernd then Begin
      if not sndPlaySound(ms.Memory, SND_MEMORY or SND_ASYNC or SND_LOOP)
        then //Zweiter Versuch
        if not sndPlaySound(ms.Memory, SND_MEMORY or SND_SYNC) then
              {ok(Ausgabekanal_wird_bereits_verwendet)};
    End else
      if not sndPlaySound(ms.Memory, SND_MEMORY or SND_SYNC) then
        ; //ok(Ausgabekanal_wird_bereits_verwendet);
    ms.Free;
  End;
    { sndPlaySound(ms.Memory, SND_MEMORY or SND_ASYNC or SND_LOOP)
       fhrt bei WinNT zu Fehler. Deshalb dort nur snd_sync
       sndPlaySound(ms.Memory, SND_MEMORY or SND_SYNC or SND_LOOP) }
end;

procedure EinzelnerTon;
var k: single;
  art: char;
  eing: string;
begin
  eing := '440s';
  repeat
    ev('Frequenz', 'Mit "s":Sinus; "o": Orgel; "r":Rechteck',
      'Geben Sie die Frequenz ein (Dann etwas warten)', eing, true);
    if gg then Begin
      sndPlaySound(nil, 0);
      exit;
    End;
    k := rr(eing);
    if pos('s', eing) > 0 then art := 's' else if pos('o', eing) > 0 then
      art := 'o' else art := 'r';
    spiele(k, k, k, k, k, k, k, k, 300, true, art, 'T' + eing);
  until false;
end;

procedure Dreiklang;
var k, kT, Q: single;
  eing: string;
  art: char;
begin
  eing := '440ws';
  repeat
    ev('Frequenz', 'Mit "w" wohltemperiert; "o": Orgel; "s":sinus',
      'Geben Sie die Frequenz ein (Dann etwas warten).', eing, true);
    if gg then Begin
      sndPlaySound(nil, 0);
      exit;
    End;
    k := rr(eing);
    if pos('s', eing) > 0 then art := 's' else if pos('o', eing) > 0 then
      art := 'o' else art := 'r';
    if pos('w', eing) > 0 then Begin
      kt := 1.189207115;
      Q := 1.498307077;
    End else Begin
      kT := 6 / 5;
      Q := 3 / 2;
    End;
    spiele(k, k * kT, k * Q, k * 2, k * 2 * kT, k * 2 * Q, k * 4, k * 8, 300, true, art, 'Dr' + eing);
  until false;
end;


end.

